plugins['toolbarstatepresence'] = (function() {

    var widget_template = pluginconfig['toolbarstatepresence']['widget_template'][''];
    var saved_presence_var={};
    var timers={};
    var intervaltimer;
    var iswhisper=0;

    return {

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~toolbarstatepresence" + "|" + hash + "\" />";
            sendcommand();
        },
        setLang: function() {
            var passedvar = { ...saved_presence_var};
            if(!('PAUSED_STATUS' in passedvar)) {
                passedvar['PAUSED_STATUS']='';
                passedvar['PAUSED_COLOR']= '';
                passedvar['PAUSED_TIMER']='<span id="tickpause_toolbarstatepresence">00:00:00</span>';
                passedvar['NAME']=botonitos[myposition].LABEL;

            } else {
                if (lang.hasOwnProperty(passedvar['PAUSED_STATUS'])) {
                    passedvar['PAUSED_STATUS'] = lang[passedvar['PAUSED_STATUS']];
                }
            }

            if(!('STATE_STATUS' in passedvar)) { passedvar['STATE_STATUS']='x'; }
            if(!('QUEUEMEMBER' in passedvar)) { passedvar['QUEUEMEMBER']=''; }

            if(!('STATE_TIMER' in passedvar)) {
               passedvar['STATE_TIMER']='<span id="tickstate_toolbarstatepresence">00:00:00</span>';
               var availabletime = localStorage.getItem("toolbarpresenceavailable");
               if(availabletime === null) {
                   var tDate = new Date();
                   var storeDate = tDate.getTime();
                   localStorage.setItem("toolbarpresenceavailable",storeDate);
                   timers['tick_toolbarstatepresence_state']=storeDate;
                   debug("toolbarstatepresence: set localstorage timer on setLang");
               } else {
                   debug("toolbarstatepresence: get localstorage timer on setLang: "+availabletime);
                   timers['tick_toolbarstatepresence_state']=availabletime;
               }
            } else {
               debug("toolbarstatepresence: skip setting timers as we have state_timer in passedvars inside setLang");
            }

            passedvar['LANG']=lang;

            dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                $('#toolbarstatepresence_paused_status').html(out);
            });
            saved_presence_var = JSON.parse(JSON.stringify(passedvar));
        },
        callback_qualify: function(nro,texto,slot) {
            if(myposition==nro) {
                var passedvar = { ...saved_presence_var};
                if(texto=='notok') {
                    passedvar['STATE_STATUS']='unregistered';
                } else {
                    passedvar['STATE_STATUS']='';
                }
                if(saved_presence_var['STATE_STATUS']!=passedvar['STATE_STATUS']) {
                    // only render if value changed
                    var tDate = new Date();
                    timers['tick_toolbarstatepresence_state']=tDate.getTime();
                    dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                        $('#toolbarstatepresence_paused_status').html(out);
                    });

                    if(passedvar['STATE_STATUS']=='' && (saved_presence_var['STATE_STATUS']!='unregistered' && saved_presence_var['STATE_STATUS']!='x' && typeof(saved_presence_var['STATE_STATUS'])!='undefined')) {
                        // reset avaiable timer except when passing from unregistered to available
                        var tDate = new Date();
                        var storeDate = tDate.getTime();
                        localStorage.setItem("toolbarpresenceavailable",storeDate);
                        debug("toolbarstatepresence: set localstorage available timer on qualify");
                        debug(passedvar['STATE_STATUS']);
                        debug(saved_presence_var['STATE_STATUS']);
                    }
                    saved_presence_var = JSON.parse(JSON.stringify(passedvar));
                }
            }
        },
        callback_onclose: function(nro,texto,slot) {
            debug("toolbarstatepresence: on close removeitem ");
            localStorage.removeItem("toolbarpresenceavailable");
        },
        callback_conference: function(nro,texto,slot) {
            if(myposition==nro) {
                var passedvar = { ...saved_presence_var};
                passedvar['STATE_STATUS']='conference';

                var tDate = new Date();
                timers['tick_toolbarstatepresence_state']=tDate.getTime();

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
            }
        },
        callback_spystart: function(nro,texto,slot) {
            if(myposition==nro) {
                var passedvar = { ...saved_presence_var};
                if(iswhisper==1) {
                    passedvar['STATE_STATUS']='whisper';
                } else {
                    passedvar['STATE_STATUS']='spy';
                }

                var tDate = new Date();
                timers['tick_toolbarstatepresence_state']=tDate.getTime();

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
            }
        },
        callback_spystop: function(nro,texto,slot) {
            if(myposition==nro) {
                iswhisper=0;
                var passedvar = { ...saved_presence_var};
                passedvar['STATE_STATUS']='';

                var tDate = new Date();
                timers['tick_toolbarstatepresence_state']=tDate.getTime();

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
            }
        },
        callback_state: function(nro,texto,slot) {
            if(myposition==nro) {
                iswhisper=0;
                var passedvar = { ...saved_presence_var};
                passedvar['STATE_STATUS']=texto;

                var tDate = new Date();
                timers['tick_toolbarstatepresence_state']=tDate.getTime();
                passedvar['STATE_TIMER']='<span id="tickstate_toolbarstatepresence">00:00:00</span>';

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
                if(texto=='DOWN') {
                    var tDate = new Date();
                    var storeDate = tDate.getTime();
                    localStorage.setItem("toolbarpresenceavailable",storeDate);
                    debug("toolbarstatepresence: set loalstorage available timer on state event");
                } else {
                    debug("toolbarstatepresence: remove loalstorage available timer on state event");
                    localStorage.removeItem("toolbarpresenceavailable");
                }
            }
        },
        callback_whisper: function(nro,texto,slot) {
            if(myposition==nro) {
                iswhisper=1;
            }
        },
        callback_getvar: function(nro,texto,slot) {

             textodecoded = Base64.decode(texto);
             partes = textodecoded.split("~");
             pertes = partes[0].split("/");
             var entity = pertes[0];
             var pos = pertes[2];
             pertes = partes[1].split(":");
             var preason = pertes[0];
             var tstamp = pertes[1];

             if(entity=='PAUSECUSTOM' && myposition==pos) {

                var tDate = new Date();

                var passedvar = { ...saved_presence_var};

                if(typeof(passedvar['STATE_STATUS'])=='undefined') {
                    // Asume down state if not set
                    passedvar['STATE_STATUS']='DOWN';
                }

                if (typeof(presence[preason]) == 'undefined') {
                    passedvar['PAUSED_COLOR']='#00d020';
                    passedvar['PAUSED_COLOR']='#FFFFFF';
                } else {
                    passedvar['PAUSED_COLOR']=presence[preason];
                }

                if (lang.hasOwnProperty(preason)) {
                    preason = lang[preason];
                }

                if(preason!='ERROR') {
                    passedvar['PAUSED_STATUS']=preason;
                    passedvar['PAUSED_TIMER']='<span id="tickpause_toolbarstatepresence">00:00:00</span>';

                    debug("toolbarstatepresence: remove loalstorage available timer on pausecustom event");
                    localStorage.removeItem("toolbarpresenceavailable");
                } else {
                    tstamp = parseInt(tDate.getTime()/1000);
                }

                if(passedvar['PAUSED_STATUS']=='') {
                    delete timers['tick_toolbarstatepresence_pause'];
                    $('#tickpause_toolbarstatepresence').text('');
                } else {
                    timers['tick_toolbarstatepresence_pause']=parseInt(tstamp)*1000;
                }


                passedvar['LANG']=lang;
                passedvar['NAME']=botonitos[myposition].LABEL;

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
             }
        },
        callback_presence: function(nro,texto,slot) {
            if(nro==myposition) {
                var passedvar = { ...saved_presence_var};
                var tDate = new Date();
	        if(texto=='') {
                    delete timers['tick_toolbarstatepresence_pause'];
                    $('#tickpause_toolbarstatepresence').text('');
	            preason='';
                    timers['tick_toolbarstatepresence_state']=tDate.getTime();
                    passedvar['STATE_TIMER']='<span id="tickstate_toolbarstatepresence">00:00:00</span>';
                    var tDate = new Date();
                    var storeDate = tDate.getTime();
                    localStorage.setItem("toolbarpresenceavailable",storeDate);
	        } else {
                    delete timers['tick_toolbarstatepresence_state'];
                    preason='paused';
                    timers['tick_toolbarstatepresence_pause']=tDate.getTime();
                    passedvar['PAUSED_TIMER']='<span id="tickpause_toolbarstatepresence">00:00:00</span>';
                    debug("toolbarstatepresence: remove loalstorage available timer on presence event");
                    localStorage.removeItem("toolbarpresenceavailable");
	        }
                passedvar['PAUSED_STATUS']=preason;

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
	    }
	},
        callback_xstatus: function(nro,texto,slot) {
            if(nro==myposition) {
                var passedvar = { ...saved_presence_var};

                if(texto=='unpaused') {

                    delete timers['tick_toolbarstatepresence_pause'];
                    $('#tickpause_toolbarstatepresence').text('');

                    passedvar['PAUSED_STATUS']='';

                } else {

                    var tDate = new Date();
                    timers['tick_toolbarstatepresence_pause']=tDate.getTime();

                    if(texto=='') {
                        preason='paused';
                    } else {
                        preason=texto;
                    }
                    passedvar['PAUSED_STATUS']=preason;
                    passedvar['PAUSED_TIMER']='<span id="tickpause_toolbarstatepresence">00:00:00</span>';
                }

                dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                    $('#toolbarstatepresence_paused_status').html(out);
                });
                saved_presence_var = JSON.parse(JSON.stringify(passedvar));
                //plugins['toolbarstatepresence'].setWithExpiry('fop2statepresence',JSON.stringify(passedvar),1000 * 60 * 10);
            }
        },
        callback_zbuttons: function() {
            if($('#toolbarstatepresence_paused_status').length<=0) {
                var newklon = $('<div id="toolbarstatepresence_paused_status">hla</div>');
                var actionbar = $('.navinputpresence');
                actionbar.before(newklon);
            }
            send("<msg data=\"GENERAL|toolbarstatepresencegetcustompause|" + myposition + "|\" />");

        },
        callback_queuemember: function(nro,texto,slot) {
            var passedvar = { ...saved_presence_var};
            let agent_channels = {}
            let all_channels = {};
            botonitos[myposition].QUEUECHANNEL.split('&').forEach(function(el) { agent_channels[el.split('|')[0]]=1;});
            Object.entries(queuesismember).forEach(function(el) { el[1].forEach( function(al){ all_channels[al]=1})});
            if(plugins['toolbarstatepresence'].checkIntersect(agent_channels,all_channels)) {
                passedvar['QUEUEMEMBER']='activequeuemember';
            } else {
                passedvar['QUEUEMEMBER']='inactivequeuemember';
            }
            dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                $('#toolbarstatepresence_paused_status').html(out);
            });
            saved_presence_var = JSON.parse(JSON.stringify(passedvar));
        },
        callback_queuemembers: function(nro,texto,slot) {
            var passedvar = { ...saved_presence_var};
            let agent_channels = {}
            let all_channels = {};
            botonitos[myposition].QUEUECHANNEL.split('&').forEach(function(el) { agent_channels[el.split('|')[0]]=1;});
            Object.entries(queuesismember).forEach(function(el) { el[1].forEach( function(al){ all_channels[al]=1})});
            if(plugins['toolbarstatepresence'].checkIntersect(agent_channels,all_channels)) {
                passedvar['QUEUEMEMBER']='activequeuemembrer';
            } else {
                passedvar['QUEUEMEMBER']='inactivequeuemember';
            }
            dust.render("toolbarstatepresencepausestatus", passedvar, function(err, out) {
                $('#toolbarstatepresence_paused_status').html(out);
            });
            saved_presence_var = JSON.parse(JSON.stringify(passedvar));
        },
        checkIntersect: function(object1,object2) {
            for (let key in object1) {
                if (object2.hasOwnProperty(key)) {
                    return true;
                }
            }
            return false;
        },
        update_timers: function() {
            var tDate = new Date();
            for (var j in timers) {
                var miparte = j.split("_");
                var i = miparte[1];
                var slot = miparte[2];
                var tick = $("#tick" + slot + "_" + i);

                elapsedTime = tDate.getTime() - timers[j];
                sec = elapsedTime / 1000;
                seconds = this.pad(parseInt(++sec % 60));
                minutes = this.pad(parseInt(sec / 60, 10) % 60);
                hours = this.pad(parseInt(sec / 3600, 10));
                tick.text(hours+':'+minutes+':'+seconds);
            }
        },
        pad: function(val) {
            return val > 9 ? val : "0" + val;
        },
        setWithExpiry: function(key, value, ttl) {
            const now = new Date()
            const item = {
                value: value,
                expiry: now.getTime() + ttl,
            }
            localStorage.setItem(key, JSON.stringify(item))
        },
        getWithExpiry: function(key,checkexpiry) {
            const itemStr = localStorage.getItem(key)
            // if the item doesn't exist, return null
            if (!itemStr) {
                return null
            }
            const item = JSON.parse(itemStr)
            const now = new Date()
            // compare the expiry time of the item with the current time
            if (now.getTime() > item.expiry && checkexpiry==1) {
                // If the item is expired return null
                return null
            }
            return item.value
        },
        init: function() {
            compiled = dust.compile(Base64.decode(widget_template),"toolbarstatepresencepausestatus");
            dust.loadSource(compiled);

            clearInterval(intervaltimer);
            intervaltimer = setInterval(function () {
                plugins['toolbarstatepresence'].update_timers();
            }, 1000);
        },

    }
}());
